#!/bin/sh

echo 'Lovely Idea';

BASE_DIR="$(dirname $(readlink -f $0))/.."
cd $BASE_DIR
echo $BASE_DIR

function clean() {
	echo "Cleaning the folder"
	$BASE_DIR/gradlew clean
	
}

function build() {
	echo "Building the project"
	$BASE_DIR/gradlew build
	
}

function test() {
	echo "Testing the project"
	$BASE_DIR/gradlew test
	
}

function run() {
	echo "Running the project"
	$BASE_DIR/gradlew run &
	_PID=$!
	sleep 3
	killpid $_PID
}

function check_syntax() {
	echo "Checking the syntax"
	echo 'TODO Tonitch: check syntax script'
	
}

function make_archive() {
	echo "Creating the archive on the parent folder"
	tar --create --gzip --exclude-vcs --exclude-vcs-ignores -f ../archive.tar.gz "${BASE_DIR}/{app/, gradle/, gralew, gradlew.bat, settings.gradle}"
}

case $1 in

	clean )
		clean ;;

	build )
		build ;;

	test )
		test ;;

	run )
		run ;;

	syntax )
		check_syntax ;;

	archive )
		clean &&
		build &&
		test &&
		run &&
		check_syntax &&
		make_archive ;;

	all )
		clean &&
		build &&
		test &&
		run &&
		check_syntax ;;
	* )
		clean &&
		build &&
		test &&
		check_syntax ;;
esac
